# -*- coding: utf-8 -*-
## modellfenster.py
## © Claus Albowski

## Importe:
import os
import platform
versionsNummer=platform.python_version()[0]
if versionsNummer=='3': from tkinter import *
else: from Tkinter import *
from simulation import Simulation
from grafikFenster import *
from modellfensterElemente import *
#### vordefinierte Dialoge
if versionsNummer=='2':
    import tkFileDialog as fileDialog
    import tkMessageBox  as tkmessagebox
else:
    import tkinter.filedialog as fileDialog
    import tkinter.messagebox as tkmessagebox
from dialoge import * # eigene
#### Spezialfunktionen
from funktionen import * #  wenn und Tabelle
from term import * # fuer die Bearbeitung von Termen
from random import randint


class ModellFensterApplication(Frame):
    
    def __init__(self, master=None, zeichenflaecheBreite=600, zeichenflaecheHoehe=600):
        Frame.__init__(self, master)
        self.breite = zeichenflaecheBreite
        self.hoehe = zeichenflaecheHoehe

        top = self.winfo_toplevel()
        ## Menübereich
        self.menuBar = Menu(top)
        top['menu'] = self.menuBar
        #### Datei-Menu
        self.dateiSubMenu = Menu(self.menuBar)
        self.menuBar.add_cascade(label='Datei', font='Sans 10 bold', menu=self.dateiSubMenu)
        self.dateiSubMenu.add_command(label='Daten einlesen', font='Sans 10 bold', command=self.onLesen)
        self.dateiSubMenu.add_command(label='Daten speichern', font='Sans 10 bold', command=self.onSpeichern)
        self.dateiSubMenu.add_command(label='aktuelles Verzeichnis setzen', font='Sans 10 bold', command=self.onVerzeichnis)
        self.dateiSubMenu.add_command(label=u'aktuell: Home-Verzeichnis', font='Sans 10 bold', command=self.onHome)
        self.dateiSubMenu.add_command(label='Beenden', font='Sans 10 bold', command=self.onBeenden)
        #### Modellentwicklungs-Menu
        self.neuSubMenu = Menu(self.menuBar)
        self.menuBar.add_cascade(label='Modellentwicklung', font='Sans 10 bold', menu=self.neuSubMenu)
        self.neuSubMenu.add_command(label='Neues Modell', font='Sans 10 bold', command=self.onNeuesModell)
        self.neuSubMenu.add_command(label='Bestandsfaktor', font='Sans 10 bold', command=self.onBestand)
        self.neuSubMenu.add_command(label='Fluss', font='Sans 10 bold', command=self.onFluss)
        self.neuSubMenu.add_command(label='Parameter', font='Sans 10 bold', command=self.onParameter)
        self.neuSubMenu.add_command(label=u'Zwischengröße', font='Sans 10 bold', command=self.onZwischengroesse)
        self.neuSubMenu.add_command(label='Wirkung', font='Sans 10 bold', command=self.onWirkung)
        self.neuSubMenu.add_command(label='Wirkung mit Maus', font='Sans 10 bold', command=self.onWirkungMaus)
        #### Bearbeiten-Menu
        self.bearbeitenSubMenu = Menu(self.menuBar)
        self.menuBar.add_cascade(label='Bearbeiten', font='Sans 10 bold', menu=self.bearbeitenSubMenu)
        self.bearbeitenSubMenu.add_command(label='Bestandsfaktor', font='Sans 10 bold', command=self.onBestandBearbeiten)
        self.bearbeitenSubMenu.add_command(label='Fluss', font='Sans 10 bold', command=self.onFlussBearbeiten)
        self.bearbeitenSubMenu.add_command(label='Parameter', font='Sans 10 bold', command=self.onParameterBearbeiten)
        self.bearbeitenSubMenu.add_command(label=u'Zwischengröße', font='Sans 10 bold', command=self.onZwischengroesseBearbeiten)
        self.bearbeitenSubMenu.add_command(label='Term', font='Sans 10 bold', command=self.onTermBearbeiten)
        self.bearbeitenSubMenu.add_command(label='Pfeile aktualisieren', font='Sans 10 bold', command=self.onPfeileAktualisieren)
        #### Tabellen-Menu
        self.tabellenSubMenu = Menu(self.menuBar)
        self.menuBar.add_cascade(label=u'Tabellen', font='Sans 10 bold', menu=self.tabellenSubMenu)
        self.tabellenSubMenu.add_command(label='Tabelle verwenden', font='Sans 10 bold', command=self.onTabelleNeu)
        self.tabellenSubMenu.add_command(label='Tabellenwerte eingeben', font='Sans 10 bold', command=self.onTabelleneingabe)
        self.tabellenSubMenu.add_command(label='Tabellenwerte interpolieren', font='Sans 10 bold', command=self.onInterpolierenAn)
        self.tabellenSubMenu.add_command(label='Tabellenwerte nicht interpolieren', font='Sans 10 bold', command=self.onInterpolierenAus)
        self.tabellenSubMenu.add_command(label='Tabelle loeschen', font='Sans 10 bold', command=self.onLoescheTabelle)
        self.tabellenSubMenu.add_command(label='Tabellenwerte anzeigen', font='Sans 10 bold', command=self.onTabelleAnzeigen)
        #### Loeschen-Menu
        self.loeschenSubMenu = Menu(self.menuBar)
        self.menuBar.add_cascade(label=u'Löschen', font='Sans 10 bold', menu=self.loeschenSubMenu)
        self.loeschenSubMenu.add_command(label='Bestandsfaktor', font='Sans 10 bold', command=self.onLoescheBestand)
        self.loeschenSubMenu.add_command(label='Fluss', font='Sans 10 bold', command=self.onLoescheFluss)
        self.loeschenSubMenu.add_command(label='Parameter', font='Sans 10 bold', command=self.onLoescheParameter)
        self.loeschenSubMenu.add_command(label=u'Zwischengröße', font='Sans 10 bold', command=self.onLoescheZwischengroesse)
        self.loeschenSubMenu.add_command(label='Wirkung', font='Sans 10 bold', command=self.onLoescheWirkung)
        #### Darstellungs-Menu
        self.darstellungSubMenu = Menu(self.menuBar)
        self.menuBar.add_cascade(label='Darstellung', font='Sans 10 bold', menu=self.darstellungSubMenu)
        self.darstellungSubMenu.add_command(label='Faktoren positionieren', font='Sans 10 bold', command=self.onFaktorPosition)
        self.darstellungSubMenu.add_command(label='alle verschieben', font='Sans 10 bold', command=self.onAlleVerschieben)
        self.darstellungSubMenu.add_command(label='Modelldaten zeigen', font='Sans 10 bold', command=self.onModelldatenZeigen)
        self.darstellungSubMenu.add_command(label='Modelldaten formatiert ausgeben', font='Sans 10 bold', command=self.onModelldatenAusgeben)
        self.darstellungSubMenu.add_command(label='Modelldiagramm speichern', font='Sans 10 bold', command=self.onBild)
        #### Hilfe-Menu
        self.hilfeSubMenu = Menu(self.menuBar)
        self.menuBar.add_cascade(label='Hilfe', font='Sans 10 bold', menu=self.hilfeSubMenu)
        self.hilfeSubMenu.add_command(label='Beispiel zeigen', font='Sans 10 bold', command=self.zeichne_Objekte)
        self.hilfeSubMenu.add_command(label='Hilfe zum Entwickeln', font='Sans 10 bold', command=self.ZeigeHilfeText1)
        self.hilfeSubMenu.add_command(label='Hilfe zu den Dateien', font='Sans 10 bold', command=self.ZeigeHilfeText2)
        self.hilfeSubMenu.add_command(label='Hilfe zu Kurztasten', font='Sans 10 bold', command=self.ZeigeHilfeText3)
        self.hilfeSubMenu.add_command(label='Hilfe zu Mausaktionen', font='Sans 10 bold', command=self.ZeigeHilfeText4)
        self.hilfeSubMenu.add_command(label=u'Hilfe zum Ändern der Modellfenstergröße', font='Sans 10 bold', command=self.ZeigeHilfeText5)

        ## Anlegen der Attribute        
        self.__simulation=Simulation.GibSimulation(self)
        self.__click_position = (100,100)
        self.__click_ID = None     # fuer linken Mausklick
        self.__neueWirkung = False # fuer grafische Verknuepfung
        self.__ausgewaehlt = None  # fuer Ziehen mit linker Maustaste gedrueckt
        ## Tk-Variable [Daten für Widgets]
        self.__modellVariable = StringVar()
        self.__modellVariable.set('')
        self.__modellGeaendert=False
        self.__bewegt = False
        self.__aktuellesVerzeichnis = '.'
        ## Definition von Ereignissen fuer das Fenster
        self.winfo_toplevel().bind("<Control-o>", self.onLesen)
        self.winfo_toplevel().bind("<Control-s>", self.onSpeichern)
        self.winfo_toplevel().bind("<Control-d>", self.onModelldatenZeigen)
        self.winfo_toplevel().bind("<Control-p>", self.onBild)
        self.winfo_toplevel().bind("<Alt-n>", self.onNeuesModell)
        self.winfo_toplevel().bind("<Alt-b>", self.onBestand)
        self.winfo_toplevel().bind("<Alt-f>", self.onFluss)
        self.winfo_toplevel().bind("<Alt-p>", self.onParameter)
        self.winfo_toplevel().bind("<Alt-z>", self.onZwischengroesse)
        self.winfo_toplevel().bind("<Alt-w>", self.onWirkung)
        self.winfo_toplevel().bind("<Alt-m>", self.onWirkungMaus)

        ## Oberflaeche erzeugen
        self.createWidgets()
        self.pack()

    def createWidgets(self):
        '''Einsatz des grid - Geometriemanagers'''
        # 1. Zeile
        self.modell_Label = Label(self, text=" Modellname: ", font='Sans 12')
        self.modell_Label.grid(row=0,column=0)
        self.modellNameLabel = Label(self, textvariable=self.__modellVariable, font='Sans 11 bold italic', width=32, bg='white', fg='black')
        self.modellNameLabel.grid(row=0,column=1)
        self.beenden_Button = Button(self, text="Beenden", font='Sans 10 bold', command=self.onBeenden)
        self.beenden_Button.grid(row=0,column=2)
        # 2. Zeile
        self.modellFrame=Frame(self)
        self.modellFrame.grid(row=1,column=0, columnspan=3)
        self.zeichenflaeche = Canvas(self.modellFrame,
                                     height=self.hoehe,
                                     width=self.breite,
                                     bg='white',
                                     scrollregion=(0, 0, 1800, 1200))
        zf=self.zeichenflaeche # lokale Hilfsvariable
        zf.grid(row=0,column=0)
        scrollX=Scrollbar(self.modellFrame,orient=HORIZONTAL,command=zf.xview)
        scrollY=Scrollbar(self.modellFrame,orient=VERTICAL,command=zf.yview)
        scrollX.grid(row=1,column=0, sticky=W+E)
        scrollY.grid(row=0,column=1, sticky=N+S)
        zf['xscrollcommand'] = scrollX.set
        zf['yscrollcommand'] = scrollY.set

        # Binden von Ereignissen an die Zeichenflaeche:
        zf.bind("<Button-1>", self.links_Mausklick)
        zf.bind("<Double-Button-1>", self.links_doppelt)
        zf.bind("<Button-3>", self.rechts_Mausklick)
        zf.bind("<ButtonRelease>", self.links_loslassen)
        zf.bind("<Motion>", self.bewegt)

    #### --------- Dateimenue ------------------------------
    def onLesen(self, evt=None):
        '''Der Modellname wird zwingend aus dem Dateinamen entnommen.'''
        simu=Simulation.GibSimulation()
        if len(Faktor.GibAlleFaktorNamen())>1: # mehr als t
            dialog=BestaetigungsDialog(self, u'Aktuelles Modell löschen?', 'Wollen Sie das wirklich?')
            if dialog.result==None: return
            if dialog.result==False: return
            if dialog.result==True:
                simu.LoescheAktuellesModell()
                CanvasElement.LoescheAlle(self.zeichenflaeche)
                self.__modellVariable.set('')
        verzeichnis = 'Modelle'
        if self.__aktuellesVerzeichnis!='.': verzeichnis = self.__aktuellesVerzeichnis
        dateiname=fileDialog.askopenfilename(parent=self,
                                               defaultextension='simdia',
                                               initialdir=verzeichnis,
                                               title="Modelldaten laden")
        if (dateiname==None) or dateiname==():
            MeldungDialog(self,'Info', 'Keine Daten gelesen!')
            return
        modellName=simu.ModellNameAusDateiNamen(dateiname)
        if not(self.SetzeModellNamen(modellName)): return
        self.__modellGeaendert=False
        daten=simu.Lies(dateiname) # Daten werden im Modell initialisiert
        # hier muessen die Werte fuer die Darstellung extrahiert werden
        if daten==None:
            MeldungDialog(self,'Info', 'Keine Daten gelesen!')
            return
        zf=self.zeichenflaeche
        for element in daten:
            if element[0]=='Bestand':
                name=element[1]
                try: pos=element[3]
                except IndexError:
                    pos=(randint(100,200),randint(100,200))
                be=BestandsElement(zf,name,pos)
            elif element[0]=='Parameter':
                name=element[1]
                try: pos=element[3]
                except IndexError:
                    pos=(randint(100,200),randint(100,200))
                pa=ParameterElement(self.zeichenflaeche,name,pos)
            elif element[0]=='Zwischengroesse':
                name=element[1]
                try: pos=element[2]
                except IndexError:
                    pos=(randint(100,200),randint(100,200))
                zg=ZwischengroesseElement(self.zeichenflaeche,name,pos)
            elif element[0]=='Fluss':
                name,von,auf=element[1],element[2],element[3]
                if len(element)==5:
                    fl=FlussElement(self.zeichenflaeche, name, von, auf, element[4])
                else:
                    fl=FlussElement(self.zeichenflaeche, name, von, auf)
            elif element[0]=='Wirkung':
                von,auf=element[1],element[2]
                if len(element)>3: orBogString=element[3]
                else: orBogString='1'
                try: orBog=int(orBogString)
                except ValueError as e:
                    orBog=1
                wi=WirkungElement(self.zeichenflaeche, von, auf, orBog)
            elif element[0]=='QuelleSenke':
                elmentObjekt=CanvasElement.nameUndElement[element[1]]
                pos=elmentObjekt.GibPosition()
                dx,dy=element[2][0]-pos[0],element[2][1]-pos[1]
                if 'Senke_' in element[1]: flussName=element[1][6:]
                elif 'Quelle_' in element[1]: flussName=element[1][7:]
                else: return # Lesefehler?
                self.VerschiebeElement(element[1],dx,dy)
                CanvasElement.AktualisiereFluss(zf,flussName)
                CanvasElement.AktualisiereWirkungenAuf(zf,flussName)

    def onSpeichern(self, evt=None):
        '''Es wird zunaechst geprueft, ob ein Modellname existiert.'''
        if self.__modellVariable.get()=='':
            self.SetzeModellNamen()
        dateiname=self.__modellVariable.get()+'.simdia'
        dateiname=fileDialog.asksaveasfilename(parent=self,
                                                 initialfile=dateiname,
                                                 defaultextension='simdia',
                                                 initialdir='Modelle',
                                                 title="Modelldaten speichern")
        if dateiname!=():
            simu=Simulation.GibSimulation()
            simu.SichereModellDaten()
            if simu.GibModellDaten()==[]:
                MeldungDialog(self,'Info', 'Keine Modelldaten definiert!')
                return
            try:
                daten=self.PositionenEinfuegen(
                    self.BogenOrientierungEinfuegen(
                        simu.GibModellDaten()))
                self.QuelleSenkeSichern(daten)
                simu.Speichere(dateiname,daten)
                self.__modellGeaendert=False
            except Exception as e:
                MeldungDialog(self,'Fehler!', str(e))
        else:
            MeldungDialog(self,'Info', 'Keine Daten geschrieben!')

    def QuelleSenkeSichern(self,daten):
        for name in CanvasElement.nameUndElement:
            element=CanvasElement.nameUndElement[name]
            if element.__class__==QuelleSenke:
                speichern=('QuelleSenke',
                           name,
                           element.GibPosition())
                daten.append(speichern)

    def BogenOrientierungEinfuegen(self, alleDaten):
        datenMit=[]
        for daten in alleDaten:
            if (daten[0]=='Wirkung'):
                we=CanvasElement.ObjektZuTag(daten[1]+'->'+daten[2])
                orBog=we.GibBogenOrientierung()
                datenMit.append((daten[0],daten[1],daten[2],orBog))
            else:
                datenMit.append(daten)
        return datenMit

    def PositionenEinfuegen(self, alleDaten):
        zf=self.zeichenflaeche
        datenMitPositionen=[]
        for daten in alleDaten:
            if (daten[0]=='Bestand'):
                x,y,xe,ye=zf.coords(daten[1])
                datenMitPositionen.append((daten[0],daten[1],daten[2],(x,y)))
            elif (daten[0]=='Parameter'):
                ## Problem Position
                x,y,xe,ye=zf.coords(daten[1])
                datenMitPositionen.append((daten[0],daten[1],daten[2],(x,y)))
            elif (daten[0]=='Zwischengroesse'):
                ## Problem Position
                x,y,xe,ye=zf.coords(daten[1])
                datenMitPositionen.append((daten[0],daten[1],(x,y)))
            else:
                datenMitPositionen.append(daten)
        return datenMitPositionen

        
    def SetzeModellNamen(self, modellName=''):
        if modellName=='': # aus dem Menue aufgerufen
            dialog=EingabeDialog(self, u'Modellnamen wählen', 'Namen eingeben')
            if dialog.result==None: return # cancel ausgewaehlt
            modellName=dialog.result
        if self.__modellVariable.get()!='':
            if self.__modellVariable.get()!=modellName:
                MeldungDialog(self,'Warnung','Zum Modellwechsel \n das Programm \n neu starten!')
                return False
        self.__modellVariable.set(modellName)
        return True

    def onHome(self):
        self.__aktuellesVerzeichnis = os.environ["HOME"]
        os.chdir(os.environ["HOME"])

    def onVerzeichnis(self):
        verzeichnisName=self.__aktuellesVerzeichnis
        if verzeichnisName=='.': verzeichnisName=''
        dialog=EingabeDialog(self, u'aktuelles Verzeichnis neu wählen', 'Namen eingeben',verzeichnisName)
        if dialog.result==None: return # cancel ausgewaehlt
        verzeichnisName=dialog.result
        try:
            os.chdir(verzeichnisName)
        except OSError as e:
            MeldungDialog(self,'Fehler','Verzeichnis existiert nicht!')
            return
        self.__aktuellesVerzeichnis = verzeichnisName

    def onBeenden(self):
        '''Verhindert unbeabsichtigtes Schliessen.
        Leider nicht gefunden, wie die Fenster-Schliessen-Methode
        ueberschrieben werden kann'''
        if self.__modellGeaendert==False: self.quit()
        else:
            antwort=tkmessagebox.askokcancel('Sicherheitsabfrage !','Wirklich beenden?',icon='warning')
            if antwort: self.quit()

    #### ---------- Modellentwicklungs-Menue -------------------------------------
    def onNeuesModell(self, evt=None):
        '''Strategie:
        - noch kein Name und kein Modell: -> Namen festlegen
        - vorhandenes Modell mit neuem Namen: -> Abfrage, ob gewollt'''
        if (len(Faktor.GibAlleFaktorNamen())<=1) and (self.__modellVariable.get()==''): # mehr als t
            self.SetzeModellNamen()
            return
        dialog=BestaetigungsDialog(self, u'Aktuelles Modell löschen?', 'Wollen Sie das wirklich?')
        if dialog.result==None:
            MeldungDialog(self,'Ergebnis :','abgebrochen')
            return
        if dialog.result==True:
            simu=Simulation.GibSimulation().LoescheAktuellesModell()
            CanvasElement.LoescheAlle(self.zeichenflaeche)
            self.__modellVariable.set('')
        dialog=EingabeDialog(self, u'Neuer Name für das Modell', 'Namen eingeben')
        name=dialog.result
        if dialog.result==None: return # cancel ausgewaehlt
        self.__modellGeaendert=True
        self.__modellVariable.set(name)
    
    def onBestand(self, evt=None):
        simu=Simulation.GibSimulation()
        dialog=EingabeDialog(self, 'neuer Bestand', 'Namen eingeben')
        name=dialog.result
        if dialog.result==None: return # cancel ausgewaehlt
        dialog=EingabeDialog(self, 'Anfangsbestand', 'Zahl eingeben')
        if dialog.result==None: return # cancel ausgewaehlt
        startwert=string_in_Zahl(dialog.result)
        faktor=simu.NeuerBestandsfaktor(name,startwert)
        if faktor!=None:
            be=BestandsElement(self.zeichenflaeche,name)
            self.__modellGeaendert=True

    def onParameter(self, evt=None):
        simu=Simulation.GibSimulation()
        dialog=EingabeDialog(self, 'neuer Parameter', 'Namen eingeben')
        name=dialog.result
        if dialog.result==None: return # cancel ausgewaehlt
        dialog=EingabeDialog(self, 'Wert angeben', 'Zahl eingeben')
        if dialog.result==None: return # cancel ausgewaehlt
        startwert=string_in_Zahl(dialog.result)        
        faktor=simu.NeuerParameter(name,startwert)
        if faktor!=None:
            pa=ParameterElement(self.zeichenflaeche,name)
            self.__modellGeaendert=True
            
    def onZwischengroesse(self, evt=None):
        simu=Simulation.GibSimulation()
        dialog=EingabeDialog(self, u'neue Zwischengröße', 'Namen eingeben')
        name=dialog.result
        if dialog.result==None: return # cancel ausgewaehlt
        faktor=simu.NeueZwischengroesse(name)
        if faktor!=None:
            zg=ZwischengroesseElement(self.zeichenflaeche,name)
            self.__modellGeaendert=True

    def onFluss(self, evt=None):
        '''Fluesse nur zwischen Bestandsfaktoren'''
        simu=Simulation.GibSimulation()
        dialog=EingabeDialog(self, 'Fluss', 'Namen eingeben')
        if dialog.result==None: return # cancel ausgewaehlt
        name=dialog.result
        # Bestandsfaktoren holen
        bestaendeNamen=simu.GibFaktorNamen('Bestandsfaktor')
        vonDialog=AuswahlDialog(self,'Faktor wählen',bestaendeNamen+['Quelle'],True)
        if vonDialog.result==None: return # bei cancel None
        von=vonDialog.result
        aufDialog=AuswahlDialog(self,'Faktor wählen',bestaendeNamen+['Senke'],True)
        if aufDialog.result==None: return # bei cancel None
        auf=aufDialog.result
        ##if auf=='Senke': auf=''
        if (von=='Quelle') and (auf=='Senke'): return # Fehler!
        fluss=simu.NeuerFluss(name, von, auf)
        fl=FlussElement(self.zeichenflaeche, name, von, auf)
        self.__modellGeaendert=True
        
    def onWirkung(self, evt=None):
        simu=Simulation.GibSimulation()
        vonDialog=AuswahlDialog(self,'Ausgangsfaktor wählen',simu.GibAlleFaktorNamen(),True)
        if vonDialog.result==None: return # bei cancel None
        von=vonDialog.result
        ziele=[]+simu.GibFaktorNamen('Fluss')+simu.GibFaktorNamen('Zwischengroesse')
        if von in ziele: ziele.remove(von)
        aufDialog=AuswahlDialog(self,
                                'Zielfaktor wählen',
                                ziele,
                                True)
        if aufDialog.result==None: return # bei cancel None
        auf=aufDialog.result
        wirkung=Simulation.GibSimulation().NeueWirkung(von, auf)
        wi=WirkungElement(self.zeichenflaeche, von, auf)
        self.__modellGeaendert=True

    def onWirkungMaus(self, evt=None):
        '''Wirkung mit Maus:
        Ausgangsfaktor anklicken, Maus zu Zielfaktor ziehen
        Aktion wird bei der Mausbehandlung realisiert'''
        self.__neueWirkung = True        

    #### ----------- Bearbeiten-Menu ----------------------------------------
    def onBestandBearbeiten(self, bestandsName=None):
        bestand=self.HoleFaktor('Bestandsfaktor', bestandsName)
        if bestand==None: return False # cancel angeklickt
        werte=self.HoleWerte(u'Bestandsfaktor ändern',
                             ['Bestand','Wert'],
                             [bestand.GibNamen(),str(bestand.GibStartwert())])
        if werte==None: return False # cancel angeklickt
        if bestand.GibNamen()!=werte[0]:
            self.NeuerFaktorName(bestand,werte[0])
            self.__modellGeaendert=True
        if str(bestand.GibStartwert())!=werte[1]:
            self.NeuerStartwert(bestand,string_in_Zahl(werte[1]))
            self.__modellGeaendert=True
        return True

    def onFlussBearbeiten(self, flussName=None):
        fluss=self.HoleFaktor('Fluss', flussName)
        if fluss==None: return False # cancel angeklickt
        werte=self.HoleWerte(u'Fluss ändern',
                             ['Name','Term'],
                             [fluss.GibNamen(),fluss.GibTerm()],
                             30) # Eingabefeld breiter
        if werte==None: return False # cancel angeklickt
        if fluss.GibNamen()!=werte[0]:
            if not(self.NeuerFaktorName(fluss,werte[0])):
                return False
        if fluss.GibTerm()!=werte[1]:
            ok=False
            while not ok:
                ok=fluss.SetzeTerm(werte[1])
                if not ok:
                    werte=self.HoleWerte(u'Fluss ändern',
                                         ['Name','Term'],
                                         [fluss.GibNamen(),werte[1]],
                                         30) # Eingabefeld breiter
                    if werte==None: return False # cancel angeklickt        
        self.__modellGeaendert=True
        return True

    def onParameterBearbeiten(self, parameterName=None):
        parameter=self.HoleFaktor('Parameter', parameterName)
        if parameter==None: return False # cancel angeklickt
        if parameter.GibTerm()==None:
            werte=self.HoleWerte(u'Parameter ändern',
                                 ['Name','Startwert'],
                                 [parameter.GibNamen(),str(parameter.GibStartwert())])
            if werte==None: return False # cancel angeklickt
            if parameter.GibNamen()!=werte[0]:
                self.NeuerFaktorName(parameter,werte[0])
                self.__modellGeaendert=True
            if str(parameter.GibStartwert())!=werte[1]:
                if parameter.GibTabelle()!=None:
                    abfrage=BestaetigungsDialog(self,
                                            u'Parameter hat Werte als Tabelle',
                                            'Tabelle löschen?')
                    if abfrage.result in [False, None]:
                        self.onTabelleneingabe(auswahl)
                        return
                self.NeuerStartwert(parameter,string_in_Zahl(werte[1]))
                self.__modellGeaendert=True
        else:
            werte=self.HoleWerte(u'Parameter ändern',
                                 ['Name','Term'],
                                 [parameter.GibNamen(),parameter.GibTerm()])
            if werte==None: return False # cancel angeklickt
            if parameter.GibNamen()!=werte[0]:
                self.NeuerFaktorName(parameter,werte[0])
                self.__modellGeaendert=True
            if parameter.GibTerm()!=werte[1]:
                self.NeuerTerm(parameter,werte[1])
                self.__modellGeaendert=True
        return True

    def onZwischengroesseBearbeiten(self, zwischengroesseName=None):
        zg=self.HoleFaktor('Zwischengroesse', zwischengroesseName)
        if zg==None: return False # cancel angeklickt
        werte=self.HoleWerte(u'Zwischengröße ändern',
                             ['Name','Term'],
                             [zg.GibNamen(),zg.GibTerm()],
                             30) # Eingabefeld breiter
        if werte==None: return False # cancel angeklickt
        if zg.GibNamen()!=werte[0]:
            self.NeuerFaktorName(zg,werte[0])
            self.__modellGeaendert=True
        if zg.GibTerm()!=werte[1]:
            ok=False
            while not ok:
                ok=zg.SetzeTerm(werte[1])
                if not ok:
                    werte=self.HoleWerte(u'Zwischengröße ändern',
                                         ['Name','Term'],
                                         [zg.GibNamen(),werte[1]],
                                         30) # Eingabefeld breiter
                    if werte==None: return False # cancel an geklickt        
            self.__modellGeaendert=True
        return True
        
    def onTermBearbeiten(self):
        '''Terme gibt es nicht bei Bestandsgroessen,
        Parameter haben keine Eingaenge'''
        namen=[]+Simulation.GibSimulation().GibFaktorNamen('Fluss')
        namen+=Simulation.GibSimulation().GibFaktorNamen('Zwischengroesse')
        parameterNamen=Simulation.GibSimulation().GibFaktorNamen('Parameter')
        dialog1=AuswahlDialog(self,u'Faktor wählen',namen+parameterNamen, True)
        if dialog1.result==None: return False # cancel angeklickt
        auswahl=dialog1.result
        self.termBearbeiten(auswahl) ## wegen Auswahl durch doppeltem Mausklick

    def termBearbeiten(self, auswahl):
        faktor=Faktor.FaktorZuNamen(auswahl)
        if faktor==None: return
        if faktor.HatTabelle():
            abfrage=BestaetigungsDialog(self,
                                    u'Parameter hat Werte als Tabelle',
                                    'Tabelle löschen?')
            if abfrage.result in [False, None]:
                self.onTabelleneingabe(auswahl)
                return
            else:
                self.onLoescheTabelle(auswahl)
                if parameter.GibTabelle()!=None:
                    return  # Tabelle nicht geloescht -> Abbruch
        dialog=TermEingabeDialog(self, auswahl, 'Term', faktor.GibTerm())
        if dialog.result==None: return False # cancel an geklickt
        neuerTerm=dialog.result
        if faktor.GibTerm()!=neuerTerm:
            if not faktor.SetzeTerm(neuerTerm): # einmaliger Korrekturversuch
                werte=self.HoleWerte(u'Term ändern',
                                     ['Name','Term'],
                                     [faktor.GibNamen(),neuerTerm],
                                     30) # Eingabefeld breiter
                if werte==None: return False # cancel an geklickt
                if not faktor.SetzeTerm(werte[1]):
                    return False # endgueltiger Abbruch
        self.__modellGeaendert=True
        return True

    def onPfeileAktualisieren(self):
        '''Nach dem Verschieben von Elementen muessen Wirkungs-
        und Fluss-Pfeile aktualisiert werden'''
        MeldungDialog(self,'TODO',
                      'Aktualisiert werden sollten nur die Pfeile\n'
                      +'zu verschobenen Elementen.\n'
                      +'Die Klasse CanvasElement sollte das verwalten.')
    
    #### Hilfsmethoden dafuer
    def HoleFaktor(self, typ, faktorName):
        if faktorName==None:
            faktorName=self.FaktorWaehlenDialog(typ)
        if faktorName==None: return None # cancel an geklickt
        return Faktor.FaktorZuNamen(faktorName)
    
    def HoleWerte(self, titel, labelListe, inhaltListe, spezielleBreite=20):
        dialog=N_EingabenDialog(self,titel,labelListe, inhaltListe, spezielleBreite)
        if dialog.result==None: return None # cancel an geklickt
        return dialog.result[0],dialog.result[1]
        
    def NeuerFaktorName(self,faktor,neuerName):
        '''aendert bei neuem Namen den Faktornamen und gibt True zurueck'''
        alterName=faktor.GibNamen()
        if neuerName==alterName: return False
        simu=Simulation.GibSimulation()
        if not(simu.AendereFaktorNamen(alterName, neuerName)):
            return False
        ## Alle ueber die Namensaenderung informieren
        CanvasElement.AendereNamen(self.zeichenflaeche,alterName,neuerName)
        return True
        
    def NeuerStartwert(self, faktor, startwert):
        if startwert!=faktor.GibStartwert():
            faktor.SetzeStartwert(startwert)

    def NeuerTerm(self, faktor, term):
        if term!=faktor.GibTerm():
            faktor.SetzeTerm(term)
        
#### ---------- Tabellen-Menue ------------------------------------
    def onTabelleNeu(self):
        auswahl=self.FaktorWaehlenDialog(['Parameter','Zwischengroesse'])
        if auswahl==None: return # cancel angeklickt
        faktor=Faktor.FaktorZuNamen(auswahl)
        faktor.NeueTabelle()
        return True

    def onTabelleAnzeigen(self):
        '''Tabelle anzeigen'''
        auswahl=self.FaktorWaehlenDialog(['Parameter','Zwischengroesse'])
        if auswahl==None: return False # cancel angeklickt
        faktor=Faktor.FaktorZuNamen(auswahl)
        if faktor.GibTabelle()==None:
            MeldungDialog(self,'Achtung!','Parameterwert ist konstant oder Term!')
            return False
        tabellenWerte=faktor.GibTabellenWerte() # Paar von (Liste-Stellen (Zeiten) , Liste-Werte)
        if faktor.__class__==Zwischengroesse:
            ausgabeTabelle=[[faktor.GibTabellenWirkFaktor(),auswahl]] 
        else:
            ausgabeTabelle=[['t',auswahl]]
        for i in range(len(tabellenWerte[0])):
            ausgabeTabelle.append([str(tabellenWerte[0][i]),str(tabellenWerte[1][i])])
        dialog=TabellenAusgabeDialog(self,
                                     u'Tabellenausgabe',
                                     ausgabeTabelle)
        return True

    def onTabelleneingabe(self, auswahl=None): # auswahl bekannt, wenn intern aufgerufen
        if auswahl==None:
            faktorNamen=self.HoleFaktorenMitTabelle()
            dialog=AuswahlDialog(self, u'Faktor wählen', faktorNamen, True)
            auswahl=dialog.result
            if auswahl==None: return False # cancel angeklickt
        faktor=Faktor.FaktorZuNamen(auswahl)
        if faktor.GibTabelle()==None:
            MeldungDialog(self,'Achtung!',
                          'Parameterwert ist konstant oder Term!\n'+
                          'Tabelle vorher anlegen.')
            return False
        tabellenWerte=faktor.GibTabellenWerte() # Paar von Liste Zeiten / Liste Werte
        dialog=TabellenEingabeDialog(self, "Tabellenwerte "+auswahl,
                                             ['t',auswahl],tabellenWerte[0],tabellenWerte[1])
        if dialog.result==None: return False
        zeitenStrings,werteStrings=dialog.result
        zeiten, werte=[],[]
        try:
            for i in range(len(zeitenStrings)):
                zeiten.append(float(zeitenStrings[i]))
                werte.append(float(werteStrings[i]))
                if float(zeitenStrings[i])==0.0:
                    faktor.SetzeStartwert(float(werteStrings[i]))
        except ValueError as e:
            self.Meldung("Fehler bei den Eingaben")
            return False
        faktor.SetzeTabellenWerte(zeiten, werte)
        self.__modellGeaendert=True
        return True
        
    def onInterpolierenAn(self):
        self.TabelleInterpolieren(True)

    def onInterpolierenAus(self):
        self.TabelleInterpolieren(False)

    def TabelleInterpolieren(self, interpolieren=True):
        namen=self.HoleFaktorenMitTabelle()
        dialog=AuswahlDialog(self,'Faktor wählen',namen,True)
        if dialog.result==None: return # kein Parameter gewaehlt
        name=dialog.result
        faktor=Faktor.FaktorZuNamen(name)
        faktor.GibTabelle().SetzeInterpolieren(interpolieren)
        self.__modellGeaendert=True

    def onLoescheTabelle(self, parameterName=None):
        if parameterName==None:
            simu=Simulation.GibSimulation()
            parameterDialog=AuswahlDialog(self,
                                          'Parameter wählen',
                                          simu.GibFaktorNamen('Parameter'),
                                          True)
            if parameterDialog.result==None:
                return False # kein Parameter gewaehlt
            parameterName=parameterDialog.result
        parameter=Faktor.FaktorZuNamen(parameterName)
        parameter.LoescheTabelle()
        self.__modellGeaendert=True
        return True

    def HoleFaktorenMitTabelle(self):
        namen=Simulation.GibSimulation().GibAlleFaktorNamen()
        habenTabelle=[]
        for name in namen:
            if Faktor.FaktorZuNamen(name).HatTabelle():
                habenTabelle.append(name)
        return habenTabelle
        
    def onTabelleAnzeigen(self):
        '''Tabelle anzeigen'''
        namen=self.HoleFaktorenMitTabelle()
        dialog=AuswahlDialog(self,'Faktor wählen',namen,True)
        if dialog.result==None: return False # kein Parameter gewaehlt
        auswahl=dialog.result
        faktor=Faktor.FaktorZuNamen(auswahl)
        tabellenWerte=faktor.GibTabellenWerte()
        if faktor.__class__==Parameter:  # Paar von Liste Zeiten / Liste Werte
            ausgabeTabelle=[['t',auswahl]]
        else:
            if faktor.GibTabellenWirkFaktorNamen()==None:
                self.Meldung('Fehler bei Wirkfaktor')
                return
            ausgabeTabelle=[[faktor.GibTabellenWirkFaktorNamen(),auswahl]]
        for i in range(len(tabellenWerte[0])):
            ausgabeTabelle.append([str(tabellenWerte[0][i]),str(tabellenWerte[1][i])])
        dialog=TabellenAusgabeDialog(self,
                                     u'Tabellenausgabe',
                                     ausgabeTabelle)
        return True


#### ---------- Loeschen-Menue ------------------------------------
    def onLoescheBestand(self):
        simu=Simulation.GibSimulation()
        bestandDialog=AuswahlDialog(self,
                                'Bestandsfaktor wählen',
                                simu.GibFaktorNamen('Bestandsfaktor'),
                                True)
        if bestandDialog.result==None: return # bei cancel None
        bestand=bestandDialog.result
        # Quellen/Senken von Fluessen zu dem Bestand muessen aus
        # der Darstellung entfernt werden:
        bestandsFaktor=Faktor.FaktorZuNamen(bestand)
        fluesseNamen=bestandsFaktor.GibZuFluesse()+bestandsFaktor.GibAbFluesse()
        fluesse=[]
        for name in fluesseNamen:
            flussElement=CanvasElement.ObjektZuTag(name)
            quelleSenke=flussElement.gibQuelleSenke()
            if quelleSenke!=None:
                CanvasElement.LoescheElement(self.zeichenflaeche,quelleSenke)
        # Bestandsobjekt loeschen
        simu.LoescheBestandsfaktor(bestand)
        self.__modellGeaendert=True
        for geloescht in simu.HoleGeloeschte():
            CanvasElement.LoescheElement(self.zeichenflaeche,
                                         CanvasElement.ObjektZuTag(geloescht))
        
    def onLoescheFluss(self):
        simu=Simulation.GibSimulation()
        flussDialog=AuswahlDialog(self,
                                'Fluss wählen',
                                simu.GibFaktorNamen('Fluss'),
                                True)
        if flussDialog.result==None: return # bei cancel None
        fluss=flussDialog.result
        # Die Wirkungen auf den Fluss muessen zunaechst geloescht werden.
        # Die Modellklasse regelt das, aber auch die Modellfensterelemente
        # muessen entfernt werden.
        for wirkung in simu.GibWirkungen():
            von,auf=wirkung.GibVon(),wirkung.GibAuf()
            if fluss in (von,auf):
                CanvasElement.LoescheElement(self.zeichenflaeche,
                                             CanvasElement.ObjektZuTag(von+'->'+auf))
        simu.LoescheFluss(fluss)
        flussElement=CanvasElement.ObjektZuTag(fluss)
        quelleSenke=flussElement.gibQuelleSenke()
        if quelleSenke!=None:
            CanvasElement.LoescheElement(self.zeichenflaeche,quelleSenke)
        self.__modellGeaendert=True
        for geloescht in Simulation.GibSimulation().HoleGeloeschte():
            CanvasElement.LoescheElement(self.zeichenflaeche,
                                         CanvasElement.ObjektZuTag(geloescht))
        
    def onLoescheParameter(self):
        simu=Simulation.GibSimulation()
        parameterDialog=AuswahlDialog(self,
                                'Parameter wählen',
                                simu.GibFaktorNamen('Parameter'),
                                True)
        if parameterDialog.result==None: return # bei cancel None
        parameter=parameterDialog.result
        simu.LoescheParameter(parameter)
        self.__modellGeaendert=True
        for geloescht in Simulation.GibSimulation().HoleGeloeschte():
            CanvasElement.LoescheElement(self.zeichenflaeche,
                                         CanvasElement.ObjektZuTag(geloescht))
        
    def onLoescheZwischengroesse(self):
        simu=Simulation.GibSimulation()
        zgDialog=AuswahlDialog(self,
                                u'Zwischengröße wählen',
                                simu.GibFaktorNamen('Zwischengroesse'),
                                True)
        if zgDialog.result==None: return # bei cancel None
        zg=zgDialog.result
        simu.LoescheZwischengroesse(zg)
        self.__modellGeaendert=True
        for geloescht in Simulation.GibSimulation().HoleGeloeschte():
            CanvasElement.LoescheElement(self.zeichenflaeche,
                                         CanvasElement.ObjektZuTag(geloescht))
        
    def onLoescheWirkung(self):
        simu=Simulation.GibSimulation()
        wirkungen=Wirkung.GibAlleWirkungen()
        wirkungsTexte=[]
        for wirkung in wirkungen:
            wirkungsTexte.append(wirkung.GibVon()+'->'+wirkung.GibAuf())
        dialog=AuswahlDialog(self,'Wirkung wählen',wirkungsTexte,True)
        if dialog.result==None: return # bei cancel None
        von,symbol,auf=dialog.result.partition('->')
        simu.LoescheWirkung(von,auf)
        CanvasElement.LoescheElement(self.zeichenflaeche,
                                     CanvasElement.ObjektZuTag(dialog.result))
        self.__modellGeaendert=True
        MeldungDialog(self,'Achtung!', 'Term in '+auf+u' ändern!')
        
    #### ---------- Darstellungs-Menue -------------------------------------
    def onFaktorPosition(self, evt=None):
        daten = CanvasElement.GibAlleFaktorNamenMitPosition()
        dialog=AuswahlDialog(self, 'Auswahl des Faktors', daten, True)
        if dialog.result==None: return # bei cancel None
        eingabe=N_EingabenDialog(self,
                                dialog.result[0],
                                ['x','y'],
                                [dialog.result[1],dialog.result[2]])
        if eingabe.result==None: return # bei cancel None
        try:
            xNeu,yNeu=float(eingabe.result[0]),float(eingabe.result[1])
            x,y=float(dialog.result[1]),float(dialog.result[2])
        except ValueError as e:
            self.Meldung('falsche Eingabe\n('+str(e)+')','ACHTUNG!')
            return
        self.VerschiebeElement(dialog.result[0], xNeu-x, yNeu-y)

    def onAlleVerschieben(self, evt=None):
        daten = CanvasElement.GibAlleFaktorNamenMitPosition()
        eingabe=N_EingabenDialog(self,
                                'Alle um ...',
                                ['dx','dy'],
                                ['0','0'])
        if eingabe.result==None: return # bei cancel None
        try:
            dx,dy=float(eingabe.result[0]),float(eingabe.result[1])
        except ValueError as e:
            self.Meldung('falsche Eingabe\n('+str(e)+')','ACHTUNG!')
            return
        for name in CanvasElement.nameUndElement:
            element=CanvasElement.nameUndElement[name]
            if element.__class__==QuelleSenke:
                self.VerschiebeElement(name, dx, dy)
        for dat in daten:
            self.VerschiebeElement(dat[0], dx, dy)

    def onModelldatenZeigen(self, evt=None):
        simu=Simulation.GibSimulation()
        simu.SichereModellDaten()
        zeilen=simu.ZeigeModellDaten()
        dialog=TextAusgabeDialog(self,
                                 'Modelldaten',
                                 self.__modellVariable.get(),
                                 zeilen)
    
    def onModelldatenAusgeben(self, evt=None):
        simu=Simulation.GibSimulation()
        simu.SichereModellDaten()
        zeilen=simu.ZeigeModellDaten()
        dateiname="Modelldaten_"+self.__modellVariable.get()+".txt"
        dateiname=fileDialog.asksaveasfilename(parent=self,
                                                 initialfile=dateiname,
                                                 defaultextension='txt',
                                                 initialdir='Modelldaten',
                                                 title="Modelldaten ausgeben")
        if dateiname!=():
            ausgabe="Modell: "+self.__modellVariable.get() +"\n\n"
            for zeile in zeilen:
                ausgabe+=zeile+'\n'
            try:
                f=open(dateiname,'w')
                f.write(str(ausgabe))
                f.close()
            except IOError as e:
                self.Meldung('Fehler beim Schreiben: '+str(e))
        
    def onBild(self, evt=None):
        dateiname="Modelldiagramm_"+self.__modellVariable.get()+".ps"
        dateiname=fileDialog.asksaveasfilename(parent=self,
                                                 initialfile=dateiname,
                                                 defaultextension='ps',
                                                 initialdir='Bilder',
                                                 title="Modelldiagramm speichern")
        if dateiname!=():
            self.zeichenflaeche.postscript(file=dateiname)
        
    #### Mausereignisse  ----------------------------------------------
    def links_Mausklick(self, event):
        self.__click_position = (event.x,event.y)
        zf = self.zeichenflaeche
        ID = zf.find_closest(event.x, event.y)
        if ID==(): return # keine Elemente vorhanden
        if CanvasElement.IstFigurID(ID[0]): # keine Klicks auf Texte
            self.__click_ID = ID[0]
            tag=zf.gettags(self.__click_ID)[0]
            element=CanvasElement.ObjektZuTag(tag)
            if element.__class__==FlussElement:
                fluss=element.name
                CanvasElement.AktualisiereFluss(zf,fluss)
            elif element.__class__==WirkungElement:
                von,auf=element.von,element.auf
                CanvasElement.AktualisiereWirkung(zf,von,auf)
            else:
                self.__ausgewaehlt=tag

    def links_doppelt(self, event):
        '''Terme bearbeiten'''
        zf = self.zeichenflaeche
        ID = zf.find_closest(event.x, event.y)
        if ID==(): return # keine Elemente vorhanden
        if CanvasElement.IstFigurID(ID[0]): # keine Klicks auf Texte
            self.__click_ID = ID[0]
            tag=zf.gettags(self.__click_ID)[0]
            element=CanvasElement.ObjektZuTag(tag)
            if element.__class__==WirkungElement:
                return # keine Terme bei Wirkungen
            elif element.__class__==BestandsElement:
                return # keine Terme bei Bestandsfaktoren
            self.termBearbeiten(tag)

    def rechts_Mausklick(self, event):
        zf = self.zeichenflaeche
        ID = zf.find_closest(event.x, event.y)
        if ID==(): return # keine Elemente vorhanden
        if CanvasElement.IstFigurID(ID[0]): # keine Klicks auf Texte
            rechtsklick=zf.gettags(ID[0])[0]
            if '->' in rechtsklick:
                von,pfeil,auf=rechtsklick.partition('->')
                we=CanvasElement.ObjektZuTag(rechtsklick)
                orBog=-1*we.GibBogenOrientierung()
                CanvasElement.LoescheElement(zf, we)
                WirkungElement(zf, von, auf, orBog)
                return
            else:
                faktor=Faktor.FaktorZuNamen(rechtsklick)
                if faktor.__class__==Bestandsfaktor:
                    self.onBestandBearbeiten(rechtsklick)
                elif faktor.__class__==Fluss:
                    self.onFlussBearbeiten(rechtsklick)
                elif faktor.__class__==Parameter:
                    self.onParameterBearbeiten(rechtsklick)
                elif faktor.__class__==Zwischengroesse:
                    self.onZwischengroesseBearbeiten(rechtsklick)
            
            
    def links_loslassen(self, event):
        zf = self.zeichenflaeche
        if self.__click_ID==None: return # keines ausgewaehlt
        if zf.gettags(self.__click_ID) not in ((),None):
            ## erster Abschnitt fuer das Zeichnen einer Wirkung mit der Maus
            ID = zf.find_closest(event.x, event.y)
            if ID==(): return # keine Elemente vorhanden
            if self.__neueWirkung:
                if CanvasElement.IstFigurID(ID[0]): # keine Klicks auf Texte
                    von=zf.gettags(self.__click_ID)[0]
                    auf=zf.gettags(ID[0])[0]
                    if von==auf: return
                    if Simulation.GibSimulation().NeueWirkung(von, auf)!=None:
                        WirkungElement(zf, von, auf)
                        self.__modellGeaendert=True
        self.__ausgewaehlt = None
        self.__click_ID = None
        self.__neueWirkung = False

    def bewegt(self, event):
        if self.__neueWirkung: return
        if self.__click_ID == None: return
        umX, umY = event.x - self.__click_position[0], event.y - self.__click_position[1]
        tags=self.zeichenflaeche.gettags(self.__click_ID)
        for tag in tags:
            if CanvasElement.IstFigurTag(tag): # Mehrfachzugriffe vermeiden
                self.__ausgewaehlt = tag
                self.VerschiebeElement(self.__ausgewaehlt, umX, umY)        
        self.__click_position = (event.x,event.y)
    
    def VerschiebeElement(self, auswahl, umX, umY):
        zf=self.zeichenflaeche
        zf.move(auswahl, umX, umY)
        objekt=CanvasElement.ObjektZuTag(auswahl)
        objekt.x=objekt.x+umX
        objekt.y=objekt.y+umY
        aktualisierteFluesse=[]
        if objekt.__class__==BestandsElement:
            faktor=Faktor.FaktorZuNamen(auswahl)
            fluesse=faktor.GibZuFluesse()+faktor.GibAbFluesse()
            for fluss in fluesse:
                aktualisierteFluesse.append(fluss)
                CanvasElement.AktualisiereFluss(zf,fluss)
        for wirkung in Simulation.GibSimulation().GibWirkungen():
            von,auf=wirkung.GibVon(),wirkung.GibAuf()
            if von == auswahl:CanvasElement.AktualisiereWirkung(zf,von,auf)
            if auf == auswahl:CanvasElement.AktualisiereWirkung(zf,von,auf)
            if von in aktualisierteFluesse:CanvasElement.AktualisiereWirkung(zf,von,auf)
            if auf in aktualisierteFluesse:CanvasElement.AktualisiereWirkung(zf,von,auf)
        
    #### ------------------------------------------------------------------------
    def FaktorWaehlenDialog(self, faktorTyp=None):
        if type(faktorTyp) is list:
            faktorNamen=[]
            for typ in faktorTyp:
                faktorNamen+=Simulation.GibSimulation().GibFaktorNamen(typ)
        else:
            faktorNamen=Simulation.GibSimulation().GibFaktorNamen(faktorTyp)
        dialog=AuswahlDialog(self,u'Faktor wählen',faktorNamen, True)
        return dialog.result # bei cancel None
        
    def FaktorenAuswahlDialog(self, faktorTyp=None):
        faktorNamen=Simulation.GibSimulation().GibFaktorNamen(faktorTyp)
        dialog=AuswahlDialog(self,'Faktor(en) wählen',faktorNamen)
        return dialog.result # bei cancel None
        
    def TermAuswahlDialog(self, faktorName):
        auswahlen=Simulation.GibSimulation().GibFaktorNamen(None)
        auswahlen.remove(faktorName)
        if faktorName in Simulation.GibSimulation().GibFaktorNamen('Parameter'):
            auswahlen=[] # Parameter haben keine Eingaenge
        else:
            auswahlen=Simulation.GibSimulation().GibFaktorNamen(None)
            auswahlen.remove(faktorName) # kein Selbstbezug
        auswahlen+=['t', 'wenn', 'wurzel','quadrat','potenz','sin','cos','exp','min','max']
        dialog=AuswahlDialog(self,u'Faktor oder Funktion wählen',auswahlen,True)
        return dialog.result # bei cancel None
        
    def Meldung(self, text, titel='Info'):
        MeldungDialog(self, titel, text)

    def ZeigeHilfeText1(self):
        TextAusgabeDialog(
            self,
            u'Hilfe zu Faktoren (Größen)',
            u'Faktoren (Größen)',
            [self.__simulation.ZeigeHilfe(1)])
    def ZeigeHilfeText2(self):
        TextAusgabeDialog(
            self,
            u'Hilfe zur Modelldefinitionsdatei',
            u'Modelldefinition',
            [self.__simulation.ZeigeHilfe(2)])
        
    def ZeigeHilfeText3(self):
        TextAusgabeDialog(
            self,
            u'Hilfe zu Kurztasten',
            u'Kurztasten',
            [u'Strg-o     Datei öffnen',
             u'Strg-s     Datei speichern',
             u'Strg-d     Modelldaten zeigen',
             u'Strg-p     Bild speichern',
             u'Alt-n      Neues Modell',
             u'Alt-b      Neuer Bestand',
             u'Alt-f      Neuer Fluss',
             u'Alt-p      Neuer Parameter',
             u'Alt-z      Neue Zwischengröße',
             u'Alt-w      Neue Wirkung',
             u'Alt-m      Neue Wirkung mit Maus'])

    def ZeigeHilfeText4(self):
        TextAusgabeDialog(
            self,
            u'Hilfe zu Mausaktionen',
            u'Mausaktion',
            [u'linke Maustaste     Ziehen von Größen (Faktoren)',
             u'rechte Maustaste    Kontext bei Größen und',
             u'      Wechsel der Bogenorientierung bei Wirkungen',
             u'Doppelklick links   Terme von Größen'])

    def ZeigeHilfeText5(self):
        TextAusgabeDialog(
            self,
            u'Hilfe zum Ändern der Modellfenstergröße',
            u'Ändern der Modellfenstergröße',
            [u'Sichern und Beenden Sie das Projekt.',
            u'Ändern Sie dann in der Programmdatei SimulationApp.py',
            u'die Breite 800 und die Höhe 800 in der Zeile ',
            u'modell_Fenster = ModellFensterApplication(root,800,800)',
            u'auf die gewünschten Werte.',
            u'Dann laden Sie das Projekt neu.'])

    #### Beispiele zeichnen
    def zeichne_Objekte(self):
        if len(Faktor.GibAlleFaktorNamen())>1: # mehr als t
            MeldungDialog(self,'Achtung !','Fenster ist nicht leer!\nFuer Beispiel Programm neu starten!')
            return
        zf = self.zeichenflaeche

        simu=Simulation.GibSimulation()
        self.__modellVariable.set('Beispielmodell')
        name='x'
        simu.NeuerBestandsfaktor(name, 3.0)
        be=BestandsElement(zf, name, pos=(200,300))
        
        name='a'
        zg=simu.NeueZwischengroesse(name)
        zg.SetzeTerm('x()')
        zge=ZwischengroesseElement(zf, name, pos=(120,150))

        simu.NeueWirkung('x', 'a')
        wi=WirkungElement(zf, 'x', 'a')

        name='v'
        fl=simu.NeuerFluss(name, '', 'x')
        fl.SetzeTerm('a()')
        fe=FlussElement(zf, name, '', 'x')
        
        simu.NeueWirkung('a', 'v')
        wi2=WirkungElement(zf, 'a', 'v')

## Alternative        
##        simu=Simulation.GibSimulation()
##        name='Gesunde'
##        simu.NeuerBestandsfaktor(name, 100.0)
##        be1=BestandsElement(zf, name, pos=(50,300))
##        
##        name='Kranke'
##        simu.NeuerBestandsfaktor(name, 1.0)
##        be2=BestandsElement(zf, name, pos=(300,350))
##
##        name='erkranken'
##        simu.NeuerFluss(name, 'Gesunde', 'Kranke')
##        fl=FlussElement(zf, name, 'Gesunde', 'Kranke')
        
#### Term-Eingabe-Dialog --------------------------------------------------
class TermEingabeDialog(EingabeDialog):

    def __init__(self, parent, title, aufgabe='', wert=''):
        '''Der Wert muss auch fuer Zahlen als String uebergeben werden.
        title ist zwingend der Name des Faktors'''
        self.aufgabe=aufgabe
        self.wert=wert
        self.parent=parent
        self.name=title
        Dialog.__init__(self, parent, title)

    def body(self):
        self.aufgabe_Label = Label(self.bodyFrame,
                                   text=self.aufgabe)
        self.aufgabe_Label.grid(row=0,column=0)
        termHilfeButton = Button(self.bodyFrame,
                                 text=u'Faktor oder Funktion wählen',
                                 width=25,
                                 command=self.termHilfeHolen)
        termHilfeButton.grid(row=0, column=1)
        self.EingabeVariable = StringVar()
        self.EingabeVariable.set(self.wert)
        self.Eingabe = Entry(self.bodyFrame,
                             textvariable=self.EingabeVariable,
                             font=meinFont,
                             width=50)
        self.Eingabe.grid(row=1,column=0,columnspan=2,padx=10)
        self.Eingabe.focus_set()

    def termHilfeHolen(self):
        auswahl=self.parent.TermAuswahlDialog(self.name)
        if auswahl==None: return None
        try:
            self.Eingabe.insert(INSERT,auswahl+'()')
        except Exception as e:
            self.destroy()
        
#### ----------------------------------------------------------------------


#### als Hauptfenster starten
if __name__=='__main__':
    root = Tk()
    modell_Fenster = ModellFensterApplication(master=root)
    modell_Fenster.master.title('Entwicklung Simulation')
    grafik_Fenster=GrafikFenster(modell_Fenster)
    ##root.wait_window(grafikfenster)
    modell_Fenster.mainloop()
    try:
        grafik_Fenster.destroy()
        root.destroy()
    except Exception: pass
